import string
from mod_python import util

class Request:
    def __init__(self, req):
        self.__req = req
        self.__fields = util.FieldStorage(self.__req)
        self.__done_headers = 0

    def has_field(self, name):
        return self.__fields.has_key(name)

    def field_value(self, name):
        field = self.__fields[name]
        if type(field) is type([]):
            value = []
            for elem in field:
                value.append(elem)
            return value
        return field

    def field_names(self):
        return self.__fields.keys()

    def get_uri(self):
        return self.__req.uri

    def get_header(self, name):
        if self.__req.headers_in.has_key(name):
            return self.__req.headers_in[name]

    def write_header(self, name, value):
        if not self.__done_headers:
            if string.lower(name) == 'content-type':
                self.__req.content_type = value
            else:
                self.__req.headers_out[name] = value

    def end_headers(self):
        if not self.__done_headers:
            self.__req.send_http_header()

    def write_content(self, data):
        self.end_headers()
        self.__req.write(data)
